# :open_file_folder: Generated Project Structure

```
.
├── /.packer/                   # Packer build associated helper templates directory.
│   ├── .banne.hbs              # Distribution script top banner comment template. 
│   └── .bin.hbs                # Distribution script bin file template used in CLI projects.
├── /.tmp/                      # Packer temporary artifacts and cache directory.
├── /__mocks__/                 # Jest mock script directory. Optional: applicable when test framework is 'jest'.
├── /coverage/                  # Coverage directory generated when running unit test on coverage mode.
├── /demo/                      # Demo source content. Optional: applicable when watch source serve is enabled.
│   ├── /build/                 # Build demo pages/scripts and assets.
│   ├── /helper/                # Watch and build demo helper script directory.
│   │   ├── require.min.js      # RequireJS static artifact. Optional: applicable when build mode is 'browser' & bundle format is 'amd'.
│   │   └── system.min.js       # SystemJS static artifact. Optional: applicable when build mode is 'browser' & bundle format is 'system'.
│   └── /watch/                 # Watch demo pages/scripts and assets.
├── /helpers/                   # Unit test helper script files. Optional: applicable only when framework is 'mocha' or 'jasmine' & test environment is not 'browser'.
├── /dist/                      # Compiled distribution artifacts directory (Generated by build task).
│   ├── /bundle                 # Directory containing main bundled (umd | amd | iife | system | ejs | esm) artifact depending on bundle build type.
│   ├── /fesm5                  # Directory containing FESM5 artifact. Optional: applicable only when es5 build is enabled.
│   ├── /fesmnext               # Directory containing FESMNEXT artifact. Optional: applicable only when esnext build is enabled.
│   ├── /styles                 # Directory containing compiled style sheets. Optional: applicable only when style support is enabled.
│   ├── /typings                # Source type definition files generated by typescript compiler. Optional: applicable only when script preprocessor is 'typescript'.
│   ├── /LICENSE                # Project license agreement file copied from project root. Optional: applicable only when included in copy files configuration.
│   ├── /package.json           # Dynamically generated Package.json file with publish artifact specific metadata.
│   └── /README.md              # Package documentation markup file copied from project root. Optional: applicable only when included in copy files configuration.
├── /node_modules/              # Node modules directory
├── /src/                       # Project source directory
│   ├── /**                     # Contain any sub source and test files and directories.
│   └── /index.{ts,js}          # Library entry point file configured in packer config. Exports in this file are exposed by bundled build artifact.
├── .babelrc                    # Babel configuration file (https://babeljs.io/).
├── .editorconfig               # Define and maintain consistent coding styles between different editors and IDE's (https://editorconfig.org/).
├── .eslintignore               # Configuration to ignore specific files and directorie when running ESLint.
├── .eslintrc.json              # ESLint configuration (https://eslint.org/). Optional: applicable only when script preprecessor is 'none'.
├── .gitignore                  # Contains files to be ignored from git repository (https://git-scm.com/docs/gitignore).
├── .packerrc.js                # Packer configuration file containing project build options (https://github.com/yohangz/packer-cli).
├── .prettierignore             # Configuration to ignore specific files and directorie when running prettier.
├── .stylelintignore            # Configuration to ignore specific files and directorie when running stylelint.
├── .stylelintrc.json           # Style lint configuration (https://stylelint.io). Optional: applicable only when style support is enabled.
├── .travis.yml                 # Travis CI configuration file (https://travis-ci.com/).
├── jasmine.json                # Jasmine test framework configuration file (https://jasmine.github.io/). Optional: applicable only when test framework is 'jasmine' & test environment is 'browser'.
├── jest.config.js              # Jest test framework configuration file (https://jestjs.io/). Optional: applicable only when test framework is 'jest'.
├── karma.conf.js               # Karma unit test runner configuration (https://karma-runner.github.io). Optional: applicable only when test environment is 'browser' & test framework is either 'mocha' or 'jasmine'.
├── LICENSE                     # License agreement file.
├── mocha.opts                  # Mocha test framework CLI configuration options file (https://mochajs.org/). Optional: applicable when test framework is 'mocha' & test environment is 'browser'.
├── package.json                # Node package configuration file (https://www.npmjs.com/).
├── postcss.config.js           # PostCSS configuration file (https://postcss.org/). Optional: applicable only when style support is enabled.
├── README.md                   # Project documentation markup file.
├── tsconfig.json               # Base typescript compiler options and configuration file (https://www.typescriptlang.org/). Optional: only applicable when script preprocessor is 'typescript'.
├── tsconfig.test.json          # Typescript compiler options and configuration file by test frameworks (https://www.typescriptlang.org/). Optional: applicable only when test framework is either 'mocha' or 'jasmine' & build mode is not 'browser' &  script preprocessor is 'typescript'.
├── tslint.json                 # TSlint configuration file (https://palantir.github.io/tslint/). Optional: applicable only when script proprocessor is 'typescript'.
└── yarn.lock                   # Yarn package lock file (https://yarnpkg.com). Optional: applicable only when package manager is 'yarn'.
```
