/// <reference types="undertaker" />
import { Logger } from '../common/logger';
import { BuildMode } from '../model/build-mode';
import { PackerOptions } from '../model/packer-options';
/**
 * Copy demo helper require.js script.
 * @param projectDir Project root directory.
 * @param log Logger reference.
 */
export declare const copyDemoHelperRequireJs: (projectDir: string, log: Logger) => import("undertaker").TaskFunction;
/**
 * Copy demo helper system.js script.
 * @param projectDir Project root directory.
 * @param log Logger reference.
 */
export declare const copyDemoHelperSystemJs: (projectDir: string, log: Logger) => import("undertaker").TaskFunction;
/**
 * Copy demo source.
 * HTML entry files if browser compliant, else javascript files.
 * @param packerOptions Packer options object.
 * @param buildMode Project build mode.
 * @param packageName Target package name.
 * @param projectDir Project root directory.
 * @param log Logger reference.
 */
export declare const copyDemoSource: (packerOptions: PackerOptions, buildMode: BuildMode, packageName: string, projectDir: string, log: Logger) => import("undertaker").TaskFunction;
/**
 * Get demo source generation gulp tasks.
 * @param packerOptions Packer options object.
 * @param buildMode Project build mode.
 * @param packageName Package configuration object.
 * @param projectDir Project root directory.
 * @param log Logger reference.
 */
export declare const getDemoSourceGenerationTasks: (packerOptions: PackerOptions, buildMode: BuildMode, packageName: string, projectDir: string, log: Logger) => import("undertaker").TaskFunction[];
